SIMPLER_ANIMAL_SETUP("sarbysonictwo", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "SKID") -- Initiate character and custom Sprite2s.
SIMPLER_ANIMAL_SETUP("sarbytailstwo", "WAIT", "ROLL", "SPNG", "RIDE", "EDGE", "FALL", "SPDA", "DASH", "SKID") -- Initiate character and custom Sprite2s.

local helpers = _G["SIMPLER_ANIMAL_HELPERS"]


addHook("PlayerSpawn", function(sarbyluas) 
    if sarbyluas.mo.skin == "sarbysonictwo" or sarbyluas.mo.skin == "sarbytailstwo" then
	sarbyluas.jumped = false
	sarbyluas.snickthokked = false
	sarbyluas.thokspeed = 1
	sarbyluas.waittimer = 300
	sarbyluas.sarbyskin = true
	sarbyluas.springmode = true
	sarbyluas.flymode = false
	sarbyluas.flytimer = 600
	end
end)

function SIMPLER_ANIMAL_HOOKS.srb2sonic_hhook(mobj)
  if helpers.getSkin(mobj) == "sarbysonictwo"
    local player = helpers.getPlayer(mobj)
	local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
	local speedthreshold = player.mo.scale / 8
    
	player.waittimer = $ - 1
	player.mo.spriteyscale = FRACUNIT
	player.mo.spritexscale = FRACUNIT
	
	if player.speed >= 1 or helpers.isAirborne(mobj)
		player.waittimer = 300
	end
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
    end
    
    if mobj.sprite2 == SPR2_GOAL then return
	elseif (mobj.sprite2 == SPR2_SPIN or mobj.sprite2 == SPR2_DEAD) then return
	elseif (player.cmd.buttons & BT_BRAKE and player.cmd.buttons & BT_ACCELERATE and not (player.cmd.buttons & BT_DRIFT) and player.speed < 1) then return "STIN", A, A, A
    elseif player.spindash then return "DRLN", A, A, D
    elseif player.rideroid then return "RIDE", A, A, A
    elseif player.waittimer <= 0 then helpers.SquaredSlow(mobj, -1) return "WAIT", A, A, F
    elseif player.pullup then return "RIDE", A, A, A
    elseif player.jumped or player.dlzrocket then return "ROLL", A, A, F
    elseif player.respawn.timer or helpers.isTricking(mobj) or player.fastfall then
      helpers.SquaredSlow(mobj, -1)
      return "ROLL", A, A, F
	elseif player.respawn.dropdash then
      helpers.SquaredSlow(mobj, -1)
      return "FALL", A, A, B
	elseif helpers.isAscending(mobj) and player.springmode then
		helpers.SquaredSlow(mobj, -1)
		return "SPNG", A, A, A
	elseif helpers.isDescending(mobj) and player.springmode then
		helpers.SquaredSlow(mobj, -1)
		return "FALL", A, A, B
    elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
      helpers.SquaredSlow(mobj, -1)
      return "DRLN", A, A, D
	elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
		helpers.SquaredSlow(mobj, -1)
		return "SKID", A, A, A
	elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "FSTN", A, A, D
	elseif helpers.isAirborne(mobj) and((player.speed <= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "SLWN", A, A, H
	elseif helpers.isAirborne(mobj) and((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "FSTN", A, A, D
	elseif mobj.sprite2 == SPR2_SLWN then
		if helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "SLWN", A, A, H
		else -- Moving sideways/backwards.
			if helpers.isMovingBackward(mobj) then
				helpers.SquaredSlow(mobj, 1)
				return "SLWN", H, H, A
			end
		end
	elseif mobj.sprite2 == SPR2_STIL or player.ebrake then return "STIN", A, A, A
	end
  end
end

function SIMPLER_ANIMAL_HOOKS.srb2tails_hhook(mobj)
  if helpers.getSkin(mobj) == "sarbytailstwo"
    local player = helpers.getPlayer(mobj)
	local machthreespeed = (K_GetKartSpeed(player, false, true) * 15) / 20
	local speedthreshold = player.mo.scale / 8
    
	player.waittimer = $ - 1
	player.mo.spriteyscale = FRACUNIT
	player.mo.spritexscale = FRACUNIT
	
	if player.speed >= 1 or helpers.isAirborne(mobj)
		player.waittimer = 300
	end
    for i = 0,108 do
      S_StopSoundByID(mobj, sfx_krta00 + i) -- Stop engine sounds.
    end
    
    if mobj.sprite2 == SPR2_GOAL then return
	elseif (mobj.sprite2 == SPR2_SPIN or mobj.sprite2 == SPR2_DEAD) then return
	elseif (player.cmd.buttons & BT_BRAKE and player.cmd.buttons & BT_ACCELERATE and not (player.cmd.buttons & BT_DRIFT) and player.speed < 1) then return "STIN", A, A, A
    elseif player.spindash then return "DRLN", A, A, D
    elseif player.rideroid then return "RIDE", A, A, A
    elseif player.waittimer <= 0 then helpers.SquaredSlow(mobj, -1) return "WAIT", A, A, F
    elseif player.pullup then return "RIDE", A, A, A
    elseif player.dlzrocket then return "DASH", A, A, B
    elseif player.jumped then return "ROLL", A, A, C
    elseif player.respawn.timer or helpers.isTricking(mobj) or player.fastfall then
      helpers.SquaredSlow(mobj, -1)
      return "ROLL", A, A, C
    elseif mobj.sprite2 == SPR2_DRLN or mobj.sprite2 == SPR2_DRRN -- Slowable drift.
      helpers.SquaredSlow(mobj, -1)
      return "DRLN", A, A, D
	elseif (player.cmd.buttons & BT_BRAKE) and helpers.isMovingForward(mobj) and not helpers.isAirborne(mobj) then
		helpers.SquaredSlow(mobj, -1)
		return "SKID", A, A, A
	elseif ((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "FSTN", A, A, B
	elseif helpers.isAirborne(mobj) and((player.speed <= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "SLWN", A, A, H
	elseif helpers.isAirborne(mobj) and((player.speed >= machthreespeed) and (player.speed >= (player.lastspeed - speedthreshold))) then
		helpers.SquaredSlow(mobj, -1)
		return "FSTN", A, A, B
	elseif mobj.sprite2 == SPR2_SLWN then
		if helpers.isMovingForward(mobj) then
			helpers.SquaredSlow(mobj, -1)
			return "SLWN", A, A, H
		else -- Moving sideways/backwards.
			if helpers.isMovingBackward(mobj) then
				helpers.SquaredSlow(mobj, 1)
				return "SLWN", H, H, A
			end
		end
	elseif mobj.sprite2 == SPR2_STIL or player.ebrake then return "STIN", A, A, A
	end
  end
end

hud.add(function(v, p)
	v.drawString(0,10,"Animation Timer " + p.springmode, V_SNAPTOLEFT, "left")
	v.drawString(0,20,"Breakdance Number " + p.springstars, V_SNAPTOLEFT, "left")
end)

addHook("PlayerThink", function(sarbyluas) -- snick thok (stolen from my pizza tower pack)
	if sarbyluas.mo == nil then return end
	if sarbyluas.mo.skin == "sarbysonictwo" then
		sarbyluas.thokspeed = FixedMul(sarbyluas.mo.scale, sarbyluas.thokspeed)
		if sarbyluas.thokspeed > 140*sarbyluas.mo.scale
			sarbyluas.thokspeed = 140*sarbyluas.mo.scale
		end
		if sarbyluas.thokspeed < 50*sarbyluas.mo.scale
			sarbyluas.thokspeed = 50*sarbyluas.mo.scale
		end
		if (sarbyluas.cmd.buttons & BT_LUAA) and sarbyluas.holdinh == 0 and sarbyluas.jumped == true and sarbyluas.snickthokked == false and not sarbyluas.fastfall and sarbyluas.spinouttimer <= 0 and sarbyluas.tumblebounces <= 0 and not sarbyluas.respawn.timer then -- if it works then it works
			P_InstaThrust(sarbyluas.mo, sarbyluas.mo.angle, (sarbyluas.thokspeed/2 + (FixedHypot(sarbyluas.rmomx, sarbyluas.rmomy))))
			S_StartSound(sarbyluas.mo, sfx_thok)
			sarbyluas.snickthokked = true
		end
	end
end)

addHook("PlayerThink", function(sarbyluas) -- the jump
	if sarbyluas.mo == nil then return end
	if sarbyluas.sarbyskin == true then
		if P_IsObjectOnGround(sarbyluas.mo) and sarbyluas.fastfall then
			sarbyluas.snickthokked = false
			sarbyluas.fastfall = 0
			sarbyluas.springmode = false
		end
		if P_IsObjectOnGround(sarbyluas.mo) and not sarbyluas.fastfall then
			sarbyluas.snickthokked = false
			sarbyluas.jumped = false
			sarbyluas.springmode = false
		end
		if (sarbyluas.cmd.buttons & BT_LUAA) and not (sarbyluas.cmd.buttons & BT_DRIFT) and not sarbyluas.fastfall and P_IsObjectOnGround(sarbyluas.mo) and sarbyluas.spinouttimer <= 0 and sarbyluas.tumblebounces <= 0 and not sarbyluas.respawn.timer then -- this code makes you jump
			if (sarbyluas.mo.eflags & MFE_VERTICALFLIP) then
				S_StartSound(sarbyluas.mo, sfx_jump)
				sarbyluas.mo.momz = -16*sarbyluas.mo.scale
				sarbyluas.jumped = true
			else
				S_StartSound(sarbyluas.mo, sfx_jump)
				sarbyluas.mo.momz = 16*sarbyluas.mo.scale
				sarbyluas.jumped = true
			end
		end
	end
end)

addHook("PlayerThink", function(sarbyluas) -- this checks for if youre holding jump
	if sarbyluas.mo == nil then return end
	if sarbyluas.sarbyskin == true then
		if (sarbyluas.cmd.buttons & BT_LUAA) then
			sarbyluas.holdinh = 1 
		else
			sarbyluas.holdinh = 0
		end
	end
end)

addHook("PlayerThink", function(sarbyluas) -- this checks for if youre holding jump
	if sarbyluas.mo == nil then return end
	if sarbyluas.sarbyskin == true then
		if sarbyluas.springstars then
			sarbyluas.springmode = true
		end
	end
end)

addHook("MobjCollide", function(p2, p1)
	if p1.valid and p2.valid and p1.type == MT_PLAYER then
		if (p1.player.sarbyskin == true) and p1 ~= p2 then
			if p1.player.jumped == true then
				if (p1.z <= p2.z+p2.height) and (p1.z+p1.height >= p2.z)
					P_DamageMobj(p2, p1, p1, 3, DMG_NORMAL)
					if (p1.eflags & MFE_VERTICALFLIP) then
						p1.momz = -16*p1.scale
					else
						p1.momz = 16*p1.scale
					end
				end
			end
		end
	end
end, MT_PLAYER)
